Loading...
Searching...
No Matches
agc2.h
Go to the documentation of this file.
/* -*- c++ -*- */
/*
* Copyright 2006,2012 Free Software Foundation, Inc.
*
* This file is part of GNU Radio
*
* SPDX-License-Identifier: GPL-3.0-or-later
*
*/
#ifndef INCLUDED_ANALOG_AGC2_H
#define INCLUDED_ANALOG_AGC2_H
#include <gnuradio/analog/api.h>
#include <gnuradio/gr_complex.h>
#include <cmath>
namespace gr {
namespace analog {
namespace kernel {
/*!
* \brief high performance Automatic Gain Control class
* \ingroup level_controllers_blk
*
* \details
* For Power the absolute value of the complex number is used.
*/
class ANALOG_API agc2_cc
{
public:
/*!
* Construct a comple value AGC loop implementation object.
*
* \param attack_rate the update rate of the loop when in attack mode.
* \param decay_rate the update rate of the loop when in decay mode.
* \param reference reference value to adjust signal power to.
* \param gain initial gain value.
* \param max_gain maximum gain value (0 for unlimited).
*/
agc2_cc(float attack_rate = 1e-1,
float decay_rate = 1e-2,
float reference = 1.0,
float gain = 1.0,
float max_gain = 0.0)
: _attack_rate(attack_rate),
_decay_rate(decay_rate),
_reference(reference),
_gain(gain),
_max_gain(max_gain){};
float decay_rate() const { return _decay_rate; }
float attack_rate() const { return _attack_rate; }
float reference() const { return _reference; }
float gain() const { return _gain; }
float max_gain() const { return _max_gain; }
void set_decay_rate(float rate) { _decay_rate = rate; }
void set_attack_rate(float rate) { _attack_rate = rate; }
void set_reference(float reference) { _reference = reference; }
void set_gain(float gain) { _gain = gain; }
void set_max_gain(float max_gain) { _max_gain = max_gain; }
gr_complex scale(gr_complex input)
{
gr_complex output = input * _gain;
float tmp = -_reference +
sqrt(output.real() * output.real() + output.imag() * output.imag());
float rate = _decay_rate;
if ((tmp) > _gain) {
rate = _attack_rate;
}
_gain -= tmp * rate;
// Not sure about this; will blow up if _gain < 0 (happens
// when rates are too high), but is this the solution?
if (_gain < 0.0)
_gain = 10e-5;
if (_max_gain > 0.0 && _gain > _max_gain) {
_gain = _max_gain;
}
return output;
}
void scaleN(gr_complex output[], const gr_complex input[], unsigned n)
{
for (unsigned i = 0; i < n; i++)
output[i] = scale(input[i]);
}
protected:
float _attack_rate; // attack rate for fast changing signals
float _decay_rate; // decay rate for slow changing signals
float _reference; // reference value
float _gain; // current gain
float _max_gain; // max allowable gain
};
class ANALOG_API agc2_ff
{
public:
/*!
* Construct a floating point value AGC loop implementation object.
*
* \param attack_rate the update rate of the loop when in attack mode.
* \param decay_rate the update rate of the loop when in decay mode.
* \param reference reference value to adjust signal power to.
* \param gain initial gain value.
* \param max_gain maximum gain value (0 for unlimited).
*/
agc2_ff(float attack_rate = 1e-1,
float decay_rate = 1e-2,
float reference = 1.0,
float gain = 1.0,
float max_gain = 0.0)
: _attack_rate(attack_rate),
_decay_rate(decay_rate),
_reference(reference),
_gain(gain),
_max_gain(max_gain){};
float attack_rate() const { return _attack_rate; }
float decay_rate() const { return _decay_rate; }
float reference() const { return _reference; }
float gain() const { return _gain; }
float max_gain() const { return _max_gain; }
void set_attack_rate(float rate) { _attack_rate = rate; }
void set_decay_rate(float rate) { _decay_rate = rate; }
void set_reference(float reference) { _reference = reference; }
void set_gain(float gain) { _gain = gain; }
void set_max_gain(float max_gain) { _max_gain = max_gain; }
float scale(float input)
{
float output = input * _gain;
float tmp = (fabsf(output)) - _reference;
float rate = _decay_rate;
if (fabsf(tmp) > _gain) {
rate = _attack_rate;
}
_gain -= tmp * rate;
// Not sure about this
if (_gain < 0.0)
_gain = 10e-5;
if (_max_gain > 0.0 && _gain > _max_gain) {
_gain = _max_gain;
}
return output;
}
void scaleN(float output[], const float input[], unsigned n)
{
for (unsigned i = 0; i < n; i++)
output[i] = scale(input[i]);
}
protected:
float _attack_rate; // attack_rate for fast changing signals
float _decay_rate; // decay rate for slow changing signals
float _reference; // reference value
float _gain; // current gain
float _max_gain; // maximum gain
};
} /* namespace kernel */
} /* namespace analog */
} /* namespace gr */
#endif /* INCLUDED_ANALOG_AGC2_H */
gr::analog::kernel::agc2_cc::gain
float gain() const
Definition agc2.h:55
gr::analog::kernel::agc2_cc::set_gain
void set_gain(float gain)
Definition agc2.h:61
gr::analog::kernel::agc2_cc::_attack_rate
float _attack_rate
Definition agc2.h:94
gr::analog::kernel::agc2_cc::set_attack_rate
void set_attack_rate(float rate)
Definition agc2.h:59
gr::analog::kernel::agc2_cc::set_decay_rate
void set_decay_rate(float rate)
Definition agc2.h:58
gr::analog::kernel::agc2_cc::_reference
float _reference
Definition agc2.h:96
gr::analog::kernel::agc2_cc::agc2_cc
agc2_cc(float attack_rate=1e-1, float decay_rate=1e-2, float reference=1.0, float gain=1.0, float max_gain=0.0)
Definition agc2.h:41
gr::analog::kernel::agc2_cc::scale
gr_complex scale(gr_complex input)
Definition agc2.h:64
gr::analog::kernel::agc2_cc::scaleN
void scaleN(gr_complex output[], const gr_complex input[], unsigned n)
Definition agc2.h:87
gr::analog::kernel::agc2_cc::_gain
float _gain
Definition agc2.h:97
gr::analog::kernel::agc2_cc::reference
float reference() const
Definition agc2.h:54
gr::analog::kernel::agc2_cc::set_max_gain
void set_max_gain(float max_gain)
Definition agc2.h:62
gr::analog::kernel::agc2_cc::_decay_rate
float _decay_rate
Definition agc2.h:95
gr::analog::kernel::agc2_cc::set_reference
void set_reference(float reference)
Definition agc2.h:60
gr::analog::kernel::agc2_cc::max_gain
float max_gain() const
Definition agc2.h:56
gr::analog::kernel::agc2_cc::decay_rate
float decay_rate() const
Definition agc2.h:52
gr::analog::kernel::agc2_cc::_max_gain
float _max_gain
Definition agc2.h:98
gr::analog::kernel::agc2_cc::attack_rate
float attack_rate() const
Definition agc2.h:53
gr::analog::kernel::agc2_ff::_attack_rate
float _attack_rate
Definition agc2.h:165
gr::analog::kernel::agc2_ff::set_decay_rate
void set_decay_rate(float rate)
Definition agc2.h:132
gr::analog::kernel::agc2_ff::_decay_rate
float _decay_rate
Definition agc2.h:166
gr::analog::kernel::agc2_ff::scale
float scale(float input)
Definition agc2.h:137
gr::analog::kernel::agc2_ff::set_reference
void set_reference(float reference)
Definition agc2.h:133
gr::analog::kernel::agc2_ff::scaleN
void scaleN(float output[], const float input[], unsigned n)
Definition agc2.h:158
gr::analog::kernel::agc2_ff::_gain
float _gain
Definition agc2.h:168
gr::analog::kernel::agc2_ff::agc2_ff
agc2_ff(float attack_rate=1e-1, float decay_rate=1e-2, float reference=1.0, float gain=1.0, float max_gain=0.0)
Definition agc2.h:114
gr::analog::kernel::agc2_ff::set_attack_rate
void set_attack_rate(float rate)
Definition agc2.h:131
gr::analog::kernel::agc2_ff::_reference
float _reference
Definition agc2.h:167
gr::analog::kernel::agc2_ff::reference
float reference() const
Definition agc2.h:127
gr::analog::kernel::agc2_ff::set_max_gain
void set_max_gain(float max_gain)
Definition agc2.h:135
gr::analog::kernel::agc2_ff::set_gain
void set_gain(float gain)
Definition agc2.h:134
gr::analog::kernel::agc2_ff::attack_rate
float attack_rate() const
Definition agc2.h:125
gr::analog::kernel::agc2_ff::max_gain
float max_gain() const
Definition agc2.h:129
gr::analog::kernel::agc2_ff::_max_gain
float _max_gain
Definition agc2.h:169
gr::analog::kernel::agc2_ff::gain
float gain() const
Definition agc2.h:128
gr::analog::kernel::agc2_ff::decay_rate
float decay_rate() const
Definition agc2.h:126
api.h
ANALOG_API
#define ANALOG_API
Definition gr-analog/include/gnuradio/analog/api.h:18
gr_complex.h
gr_complex
std::complex< float > gr_complex
Definition gr_complex.h:15
gr::analog::kernel
Definition agc.h:20
gr::analog
Definition agc.h:19
gr
GNU Radio logging wrapper.
Definition basic_block.h:29